
<!DOCTYPE HTML>
<html lang="" >
    <head>
        <meta charset="UTF-8">
        <meta content="text/html; charset=utf-8" http-equiv="Content-Type">
        <title>Vagrant · GitBook</title>
        <meta http-equiv="X-UA-Compatible" content="IE=edge" />
        <meta name="description" content="">
        <meta name="generator" content="GitBook 3.2.3">
        
        
        
    
    <link rel="stylesheet" href="gitbook/style.css">

    
            
                
                <link rel="stylesheet" href="gitbook/gitbook-plugin-highlight/website.css">
                
            
                
                <link rel="stylesheet" href="gitbook/gitbook-plugin-search/search.css">
                
            
                
                <link rel="stylesheet" href="gitbook/gitbook-plugin-fontsettings/website.css">
                
            
        

    

    
        
    
        
    
        
    
        
    
        
    
        
    

        
    
    
    <meta name="HandheldFriendly" content="true"/>
    <meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=no">
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black">
    <link rel="apple-touch-icon-precomposed" sizes="152x152" href="gitbook/images/apple-touch-icon-precomposed-152.png">
    <link rel="shortcut icon" href="gitbook/images/favicon.ico" type="image/x-icon">

    
    <link rel="next" href="Ansible.html" />
    
    
    <link rel="prev" href="./" />
    

    </head>
    <body>
        
<div class="book">
    <div class="book-summary">
        
            
<div id="book-search-input" role="search">
    <input type="text" placeholder="Type to search" />
</div>

            
                <nav role="navigation">
                


<ul class="summary">
    
    

    

    
        
        
    
        <li class="chapter " data-level="1.1" data-path="./">
            
                <a href="./">
            
                    
                    Introdução
            
                </a>
            

            
        </li>
    
        <li class="chapter active" data-level="1.2" data-path="Vagrant.html">
            
                <a href="Vagrant.html">
            
                    
                    Vagrant
            
                </a>
            

            
        </li>
    
        <li class="chapter " data-level="1.3" data-path="Ansible.html">
            
                <a href="Ansible.html">
            
                    
                    Ansible
            
                </a>
            

            
        </li>
    
        <li class="chapter " data-level="1.4" data-path="Docker.html">
            
                <a href="Docker.html">
            
                    
                    Docker
            
                </a>
            

            
        </li>
    
        <li class="chapter " data-level="1.5" data-path="GitBook.html">
            
                <a href="GitBook.html">
            
                    
                    GitBook
            
                </a>
            

            
        </li>
    

    

    <li class="divider"></li>

    <li>
        <a href="https://www.gitbook.com" target="blank" class="gitbook-link">
            Published with GitBook
        </a>
    </li>
</ul>


                </nav>
            
        
    </div>

    <div class="book-body">
        
            <div class="body-inner">
                
                    

<div class="book-header" role="navigation">
    

    <!-- Title -->
    <h1>
        <i class="fa fa-circle-o-notch fa-spin"></i>
        <a href="." >Vagrant</a>
    </h1>
</div>




                    <div class="page-wrapper" tabindex="-1" role="main">
                        <div class="page-inner">
                            
<div id="book-search-results">
    <div class="search-noresults">
    
                                <section class="normal markdown-section">
                                
                                <h1 id="vagrant">Vagrant</h1>
<h2 id="o-que-&#xE9;-o-vagrant">O que &#xE9; o Vagrant:</h2>
<p>&#xC9; uma <a href="https://www.vagrantup.com/docs/index" target="_blank">ferramenta</a> de linha de comando para criar e gerenciar o ciclo de vida de m&#xE1;quinas virtuais. </p>
<h3 id="vantagens">Vantagens:</h3>
<pre><code>- Ela possui uma interface &#xFA;nica de comunica&#xE7;&#xE3;o com os hipervisors (termo  gen&#xE9;rico para descrever um virtualizador):
    - hyperv (microsoft)
    - virtualbox (oracle)
    - vmware
    - Docker, etc
- Principio de infraestrutura como c&#xF3;digo (IaC): Atrav&#xE9;s de um c&#xF3;digo conseguimos recriar uma infra.
</code></pre><h2 id="como-funciona">Como funciona?</h2>
<p><img src="vagrant-schema.png" alt="Vagrant schema"></p>
<h2 id="vagrantfile">Vagrantfile</h2>
<p>Arquivo utilizado para descrever como configurar e provisionar uma m&#xE1;quina. Tais arquivos s&#xE3;o escritos utilizando a linguagem Ruby. Apesar de serem escritos em ruby n&#xE3;o precisamos ter conhecimento na sintaxe da linguagem para escrevermos os nossos pr&#xF3;prios Vagrantfiles.
<a href="https://www.vagrantup.com/docs/vagrantfile" target="_blank">Documenta&#xE7;&#xE3;o Vagrantfiles</a></p>
<p>O Vagrantfile possui 5 partes principais:</p>
<ul>
<li>config.vm.box: Sistema operacional.</li>
<li>config.vm.provider: Provider: virtualbox, vmware, hiperv.</li>
<li>config.vm.network: Como host enxerga o box.</li>
<li>config.vm.synced_folder: Como vc acessar&#xE1; arquivos do host. </li>
<li>config.vm.provision: O que queremos configurar.</li>
</ul>
<pre><code class="lang-ruby">Vagrant.configure(<span class="hljs-string">&quot;2&quot;</span>) <span class="hljs-keyword">do</span> |config|

  config.vm.box = <span class="hljs-string">&quot;ubuntu/trusty64&quot;</span>

  config.vm.provider <span class="hljs-string">&quot;virtualbox&quot;</span> <span class="hljs-keyword">do</span> |vb|
  <span class="hljs-comment">#   vb.gui = true</span>
      vb.memory = <span class="hljs-number">1024</span>
      vb.cpus = <span class="hljs-number">4</span>
  <span class="hljs-keyword">end</span>
  config.vm.network <span class="hljs-string">&quot;forwarded_port&quot;</span>, <span class="hljs-symbol">guest:</span> <span class="hljs-number">80</span>, <span class="hljs-symbol">host:</span> <span class="hljs-number">8080</span>
  config.vm.network <span class="hljs-string">&quot;private_network&quot;</span>, <span class="hljs-symbol">ip:</span> <span class="hljs-string">&quot;192.168.33.10&quot;</span>

  config.vm.network <span class="hljs-string">&quot;public_network&quot;</span>
  config.vm.synced_folder <span class="hljs-string">&quot;.&quot;</span>, <span class="hljs-string">&quot;/var/www/html&quot;</span>, <span class="hljs-symbol">:mount_options</span> =&gt; [<span class="hljs-string">&quot;dmode=777&quot;</span>, <span class="hljs-string">&quot;fmode=666&quot;</span>]

  config.vm.provision <span class="hljs-string">&quot;shell&quot;</span>, <span class="hljs-symbol">inline:</span> &lt;&lt;-SHELL
     apt-get update
     apt-get install -y apache2
  SHELL

<span class="hljs-keyword">end</span>
</code></pre>
<h2 id="lista-de-comandos">Lista de comandos:</h2>
<pre><code class="lang-bash">
vagrant --help
vagrant box list
vagrant autocomplete install --bash --zsh <span class="hljs-comment"># autocomplete: apenas para bash zsh</span>
vagrant init ubuntu/trusty64
vagrant up 
vagrant destroy
vagrant <span class="hljs-built_in">suspend</span>
vagrant resume
vagrant reload (aumentar a memoria e realizar o reload)
vagrant halt
vagrant ssh
vagrant status
vagrant global-status

vagrant snapshot save [vm-name] NAME
</code></pre>

                                
                                </section>
                            
    </div>
    <div class="search-results">
        <div class="has-results">
            
            <h1 class="search-results-title"><span class='search-results-count'></span> results matching "<span class='search-query'></span>"</h1>
            <ul class="search-results-list"></ul>
            
        </div>
        <div class="no-results">
            
            <h1 class="search-results-title">No results matching "<span class='search-query'></span>"</h1>
            
        </div>
    </div>
</div>

                        </div>
                    </div>
                
            </div>

            
                
                <a href="./" class="navigation navigation-prev " aria-label="Previous page: Introdução">
                    <i class="fa fa-angle-left"></i>
                </a>
                
                
                <a href="Ansible.html" class="navigation navigation-next " aria-label="Next page: Ansible">
                    <i class="fa fa-angle-right"></i>
                </a>
                
            
        
    </div>

    <script>
        var gitbook = gitbook || [];
        gitbook.push(function() {
            gitbook.page.hasChanged({"page":{"title":"Vagrant","level":"1.2","depth":1,"next":{"title":"Ansible","level":"1.3","depth":1,"path":"Ansible.md","ref":"Ansible.md","articles":[]},"previous":{"title":"Introdução","level":"1.1","depth":1,"path":"README.md","ref":"README.md","articles":[]},"dir":"ltr"},"config":{"gitbook":"*","theme":"default","variables":{},"plugins":[],"pluginsConfig":{"highlight":{},"search":{},"lunr":{"maxIndexSize":1000000,"ignoreSpecialCharacters":false},"sharing":{"facebook":true,"twitter":true,"google":false,"weibo":false,"instapaper":false,"vk":false,"all":["facebook","google","twitter","weibo","instapaper"]},"fontsettings":{"theme":"white","family":"sans","size":2},"theme-default":{"styles":{"website":"styles/website.css","pdf":"styles/pdf.css","epub":"styles/epub.css","mobi":"styles/mobi.css","ebook":"styles/ebook.css","print":"styles/print.css"},"showLevel":false}},"structure":{"langs":"LANGS.md","readme":"README.md","glossary":"GLOSSARY.md","summary":"SUMMARY.md"},"pdf":{"pageNumbers":true,"fontSize":12,"fontFamily":"Arial","paperSize":"a4","chapterMark":"pagebreak","pageBreaksBefore":"/","margin":{"right":62,"left":62,"top":56,"bottom":56}},"styles":{"website":"styles/website.css","pdf":"styles/pdf.css","epub":"styles/epub.css","mobi":"styles/mobi.css","ebook":"styles/ebook.css","print":"styles/print.css"}},"file":{"path":"Vagrant.md","mtime":"2021-08-23T13:36:23.521Z","type":"markdown"},"gitbook":{"version":"3.2.3","time":"2021-10-04T12:07:47.563Z"},"basePath":".","book":{"language":""}});
        });
    </script>
</div>

        
    <script src="gitbook/gitbook.js"></script>
    <script src="gitbook/theme.js"></script>
    
        
        <script src="gitbook/gitbook-plugin-search/search-engine.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-search/search.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-lunr/lunr.min.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-lunr/search-lunr.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-sharing/buttons.js"></script>
        
    
        
        <script src="gitbook/gitbook-plugin-fontsettings/fontsettings.js"></script>
        
    

    </body>
</html>

